﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BajoGabor_Folyok
{
    class Program
    {
        //static Folyok folyok;
        static List<Folyok> folyolista;

        static void Main(string[] args)
        {
            folyolista = new List<Folyok>();
            string[] osszesadat = File.ReadAllLines("folyok.csv");
            for (int i = 3; i < osszesadat.Length; i++)
            {
                string[] egysor = osszesadat[i].Split(';');
                string nev = egysor[0];
                double hossz = double.Parse(egysor[1]);
                double terulet = double.Parse(egysor[2]);
                string orszag = egysor[3];
                Folyok folyoksor = new Folyok(nev, hossz, terulet, orszag);
                folyolista.Add(folyoksor);
            }

            //1. feladat
            Console.WriteLine("1. feladat: Hány sora van a file-nak (csak az adatok)?");
            Console.WriteLine("     "+folyolista.Count+" sora van a file-nak.");
            Console.WriteLine();

            //2. feladat
            int leghosszabb=Leghosszabb();
            Console.WriteLine("2. feladat: Határozza meg a leghosszabb folyót!");
            Console.WriteLine("     A leghosszabb folyó a " + folyolista[leghosszabb].getNev()+" (hossza: "+ folyolista[leghosszabb].getHossz()+" km)");
            Console.WriteLine();

            //3. feladat
            double osszhossz = Osszhossz();
            Console.WriteLine("3. feladat: Határozza meg a folyók össz-hosszát!");
            Console.WriteLine("     A folyók össz-hossza: " + osszhossz + " km");
            Console.WriteLine();

            //4. feladat
            string legnagyobb = Legnagyobb();
            Console.WriteLine("4. feladat: Melyik országban található a legtöbb nagy folyó?");
            Console.WriteLine("     A legtöbb nagy folyó "+legnagyobb+"-ban található.");
            Console.WriteLine();

            //5. feladat
            Fajlbairatas();
            Console.WriteLine("5. feladat: Írasd ki stat.txt nevű file-ba az országok statisztikáját (hány darab folyó van egy-egy országban)!");
            Console.WriteLine("     A program a háttérben kiírta a programmappában található fájlba az adatokat.");

            Console.ReadKey();

        }

        private static void Fajlbairatas()
        {
            Dictionary<string, int> orszagDbOsszes = new Dictionary<string, int>();
            for (int i = 0; i < folyolista.Count; i++)
            {
                if (orszagDbOsszes.ContainsKey(folyolista[i].getOrszag()))
                {
                    orszagDbOsszes[folyolista[i].getOrszag()]++;
                }
                else
                {
                    orszagDbOsszes.Add(folyolista[i].getOrszag(), 1);
                }
            }
            string fajlba = "";
            foreach (var item in orszagDbOsszes)
            {
                fajlba += item.Key + " " + item.Value + "\r\n";
            }
            File.WriteAllText("stat.txt", fajlba);
        }

        private static string Legnagyobb()
        {
            string legnagyobb = "";
            int maximum = 0;
            Dictionary<string, int> orszagdb = new Dictionary<string, int>();
            for (int i = 0; i < folyolista.Count; i++)
            {
                if (folyolista[i].getTerulet()>2000000)
                {
                    if (orszagdb.ContainsKey(folyolista[i].getOrszag()))
                    {
                        orszagdb[folyolista[i].getOrszag()]++;
                    }
                    else
                    {
                        orszagdb.Add(folyolista[i].getOrszag(),1);
                    }
                }
            }
            
            foreach (var item in orszagdb)
            {
                if (item.Value>maximum)
                {
                    maximum = item.Value;
                    legnagyobb = item.Key;
                }
            }

            return legnagyobb;
        }

        private static double Osszhossz()
        {
            double osszhossz = 0;
            for (int i = 0; i < folyolista.Count; i++)
            {
                osszhossz+= folyolista[i].getHossz();
            }
            return osszhossz;
        }

        private static int Leghosszabb()
        {
            int leghosszabb = 0;
            for (int i = 1; i < folyolista.Count; i++)
            {
                if (folyolista[i].getHossz()>folyolista[leghosszabb].getHossz())
                {
                    leghosszabb = i;
                }
            }
            return leghosszabb;
        }
    }
}
